diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_mutl.c openssl-1.0.0q/crypto/pkcs12/p12_mutl.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_mutl.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_mutl.c	2017-04-25 16:23:40.586621201 +0200
@@ -56,9 +56,12 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 #ifndef OPENSSL_NO_HMAC
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/hmac.h>
 #include <openssl/rand.h>
 #include <openssl/pkcs12.h>
@@ -69,7 +72,7 @@
 {
 	const EVP_MD *md_type;
 	HMAC_CTX hmac;
-	unsigned char key[EVP_MAX_MD_SIZE], *salt;
+	unsigned char key[EVP_MAX_MD_SIZE], *salt; /* ARRAY OK 2004-02-18 yngve */
 	int saltlen, iter;
 	int md_size;
 
@@ -83,8 +86,18 @@
 	saltlen = p12->mac->salt->length;
 	if (!p12->mac->iter) iter = 1;
 	else iter = ASN1_INTEGER_get (p12->mac->iter);
-    	if(!(md_type =
-		 EVP_get_digestbyobj (p12->mac->dinfo->algor->algorithm))) {
+
+#ifndef  OPENSSL_NO_SHA
+	if(
+#ifndef LIBOPEAY_DISABLE_SHA1_PARTIAL
+		g_turn_off_sha1 &&
+#endif
+		OBJ_obj2nid(p12->mac->dinfo->algor->algorithm) == NID_sha1)
+			md_type = EVP_sha1();
+	else
+#endif
+	if(!(md_type =
+		EVP_get_digestbyobj (p12->mac->dinfo->algor->algorithm))) {
 		PKCS12err(PKCS12_F_PKCS12_GEN_MAC,PKCS12_R_UNKNOWN_DIGEST_ALGORITHM);
 		return 0;
 	}
@@ -108,7 +121,7 @@
 /* Verify the mac */
 int PKCS12_verify_mac(PKCS12 *p12, const char *pass, int passlen)
 {
-	unsigned char mac[EVP_MAX_MD_SIZE];
+	unsigned char mac[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 	unsigned int maclen;
 	if(p12->mac == NULL) {
 		PKCS12err(PKCS12_F_PKCS12_VERIFY_MAC,PKCS12_R_MAC_ABSENT);
@@ -119,7 +132,7 @@
 		return 0;
 	}
 	if ((maclen != (unsigned int)p12->mac->dinfo->digest->length)
-	|| memcmp (mac, p12->mac->dinfo->digest->data, maclen)) return 0;
+	|| op_memcmp (mac, p12->mac->dinfo->digest->data, maclen)) return 0;
 	return 1;
 }
 
@@ -128,7 +141,7 @@
 int PKCS12_set_mac(PKCS12 *p12, const char *pass, int passlen,
 	     unsigned char *salt, int saltlen, int iter, const EVP_MD *md_type)
 {
-	unsigned char mac[EVP_MAX_MD_SIZE];
+	unsigned char mac[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 	unsigned int maclen;
 
 	if (!md_type) md_type = EVP_sha1();
@@ -165,7 +178,7 @@
 	}
 	if (!saltlen) saltlen = PKCS12_SALT_LEN;
 	p12->mac->salt->length = saltlen;
-	if (!(p12->mac->salt->data = OPENSSL_malloc (saltlen))) {
+	if (!(p12->mac->salt->data = (unsigned char *) OPENSSL_malloc (saltlen))) {
 		PKCS12err(PKCS12_F_PKCS12_SETUP_MAC, ERR_R_MALLOC_FAILURE);
 		return 0;
 	}
@@ -173,7 +186,7 @@
 		if (RAND_pseudo_bytes (p12->mac->salt->data, saltlen) < 0)
 			return 0;
 	}
-	else memcpy (p12->mac->salt->data, salt, saltlen);
+	else op_memcpy (p12->mac->salt->data, salt, saltlen);
 	p12->mac->dinfo->algor->algorithm = OBJ_nid2obj(EVP_MD_type(md_type));
 	if (!(p12->mac->dinfo->algor->parameter = ASN1_TYPE_new())) {
 		PKCS12err(PKCS12_F_PKCS12_SETUP_MAC, ERR_R_MALLOC_FAILURE);
@@ -184,3 +197,4 @@
 	return 1;
 }
 #endif
+#endif  // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_npas.c openssl-1.0.0q/crypto/pkcs12/p12_npas.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_npas.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_npas.c	2017-04-25 16:23:40.587620490 +0200
@@ -56,9 +56,12 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
+
 #include <openssl/pem.h>
 #include <openssl/err.h>
 #include <openssl/pkcs12.h>
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_p8d.c openssl-1.0.0q/crypto/pkcs12/p12_p8d.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_p8d.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_p8d.c	2017-04-25 16:23:40.588620617 +0200
@@ -56,13 +56,19 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
+#include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 PKCS8_PRIV_KEY_INFO *PKCS8_decrypt(X509_SIG *p8, const char *pass, int passlen)
 {
-	return PKCS12_item_decrypt_d2i(p8->algor, ASN1_ITEM_rptr(PKCS8_PRIV_KEY_INFO), pass,
+	return (PKCS8_PRIV_KEY_INFO *) PKCS12_item_decrypt_d2i(p8->algor, ASN1_ITEM_rptr(PKCS8_PRIV_KEY_INFO), pass,
 					passlen, p8->digest, 1);
 }
+#endif // LIBOPEAY_PKCS12_SUPPORT
 
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_p8e.c openssl-1.0.0q/crypto/pkcs12/p12_p8e.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_p8e.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_p8e.c	2017-04-25 16:23:40.588620617 +0200
@@ -56,9 +56,14 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
+#include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 X509_SIG *PKCS8_encrypt(int pbe_nid, const EVP_CIPHER *cipher,
 			 const char *pass, int passlen,
@@ -73,7 +78,14 @@
 		goto err;
 	}
 
-	if(pbe_nid == -1) pbe = PKCS5_pbe2_set(cipher, iter, salt, saltlen);
+	if(pbe_nid == -1)
+	{
+#ifndef OPERA_SMALL_VERSION
+		pbe = PKCS5_pbe2_set(cipher, iter, salt, saltlen);
+#else
+		pbe = NULL;
+#endif
+	}
 	else pbe = PKCS5_pbe_set(pbe_nid, iter, salt, saltlen);
 	if(!pbe) {
 		PKCS12err(PKCS12_F_PKCS8_ENCRYPT, ERR_R_ASN1_LIB);
@@ -95,3 +107,4 @@
 	X509_SIG_free(p8);
 	return NULL;
 }
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_utl.c openssl-1.0.0q/crypto/pkcs12/p12_utl.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_utl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_utl.c	2017-04-25 16:23:40.589620745 +0200
@@ -56,9 +56,14 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
+#include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Cheap and nasty Unicode stuff */
 
@@ -66,9 +71,9 @@
 {
 	int ulen, i;
 	unsigned char *unitmp;
-	if (asclen == -1) asclen = strlen(asc);
+	if (asclen == -1) asclen = op_strlen(asc);
 	ulen = asclen*2  + 2;
-	if (!(unitmp = OPENSSL_malloc(ulen))) return NULL;
+	if (!(unitmp = (unsigned char *) OPENSSL_malloc(ulen))) return NULL;
 	for (i = 0; i < ulen - 2; i+=2) {
 		unitmp[i] = 0;
 		unitmp[i + 1] = asc[i>>1];
@@ -81,6 +86,7 @@
 	return unitmp;
 }
 
+#ifndef OPERA_SMALL_VERSION
 char *OPENSSL_uni2asc(unsigned char *uni, int unilen)
 {
 	int asclen, i;
@@ -94,11 +100,14 @@
 	asctmp[asclen - 1] = 0;
 	return asctmp;
 }
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 int i2d_PKCS12_bio(BIO *bp, PKCS12 *p12)
 {
 	return ASN1_item_i2d_bio(ASN1_ITEM_rptr(PKCS12), bp, p12);
 }
+#endif
 
 #ifndef OPENSSL_NO_FP_API
 int i2d_PKCS12_fp(FILE *fp, PKCS12 *p12)
@@ -107,10 +116,13 @@
 }
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 PKCS12 *d2i_PKCS12_bio(BIO *bp, PKCS12 **p12)
 {
 	return ASN1_item_d2i_bio(ASN1_ITEM_rptr(PKCS12), bp, p12);
 }
+#endif
+
 #ifndef OPENSSL_NO_FP_API
 PKCS12 *d2i_PKCS12_fp(FILE *fp, PKCS12 **p12)
 {
@@ -124,19 +136,22 @@
 			NID_x509Certificate, NID_certBag);
 }
 
+#ifndef OPERA_SMALL_VERSION
 PKCS12_SAFEBAG *PKCS12_x509crl2certbag(X509_CRL *crl)
 {
 	return PKCS12_item_pack_safebag(crl, ASN1_ITEM_rptr(X509_CRL),
 			NID_x509Crl, NID_crlBag);
 }
+#endif
 
 X509 *PKCS12_certbag2x509(PKCS12_SAFEBAG *bag)
 {
 	if(M_PKCS12_bag_type(bag) != NID_certBag) return NULL;
 	if(M_PKCS12_cert_bag_type(bag) != NID_x509Certificate) return NULL;
-	return ASN1_item_unpack(bag->value.bag->value.octet, ASN1_ITEM_rptr(X509));
+	return (X509 *) ASN1_item_unpack(bag->value.bag->value.octet, ASN1_ITEM_rptr(X509));
 }
 
+#ifndef OPERA_SMALL_VERSION
 X509_CRL *PKCS12_certbag2x509crl(PKCS12_SAFEBAG *bag)
 {
 	if(M_PKCS12_bag_type(bag) != NID_crlBag) return NULL;
@@ -144,3 +159,5 @@
 	return ASN1_item_unpack(bag->value.bag->value.octet,
 							ASN1_ITEM_rptr(X509_CRL));
 }
+#endif
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/pk12err.c openssl-1.0.0q/crypto/pkcs12/pk12err.c
--- openssl-1.0.0q.orig/crypto/pkcs12/pk12err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/pk12err.c	2017-04-25 16:23:40.590621151 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/pkcs12.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/pkcs12.h openssl-1.0.0q/crypto/pkcs12/pkcs12.h
--- openssl-1.0.0q.orig/crypto/pkcs12/pkcs12.h	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/pkcs12.h	2017-04-25 16:23:40.591620999 +0200
@@ -257,9 +257,13 @@
 PKCS12 *PKCS12_add_safes(STACK_OF(PKCS7) *safes, int p7_nid);
 
 int i2d_PKCS12_bio(BIO *bp, PKCS12 *p12);
+#ifndef OPENSSL_NO_FP_API
 int i2d_PKCS12_fp(FILE *fp, PKCS12 *p12);
+#endif
 PKCS12 *d2i_PKCS12_bio(BIO *bp, PKCS12 **p12);
+#ifndef OPENSSL_NO_FP_API
 PKCS12 *d2i_PKCS12_fp(FILE *fp, PKCS12 **p12);
+#endif
 int PKCS12_newpass(PKCS12 *p12, char *oldpass, char *newpass);
 
 /* BEGIN ERROR CODES */
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/.gitignore openssl-1.0.0q/crypto/pkcs7/.gitignore
--- openssl-1.0.0q.orig/crypto/pkcs7/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/.gitignore	2017-04-25 16:23:40.591620999 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_asn1.c openssl-1.0.0q/crypto/pkcs7/pk7_asn1.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_asn1.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_asn1.c	2017-04-25 16:23:40.594621380 +0200
@@ -56,32 +56,37 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/pkcs7.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* PKCS#7 ASN1 module */
 
 /* This is the ANY DEFINED BY table for the top level PKCS#7 structure */
 
-ASN1_ADB_TEMPLATE(p7default) = ASN1_EXP_OPT(PKCS7, d.other, ASN1_ANY, 0);
-
-ASN1_ADB(PKCS7) = {
-	ADB_ENTRY(NID_pkcs7_data, ASN1_NDEF_EXP_OPT(PKCS7, d.data, ASN1_OCTET_STRING_NDEF, 0)),
-	ADB_ENTRY(NID_pkcs7_signed, ASN1_NDEF_EXP_OPT(PKCS7, d.sign, PKCS7_SIGNED, 0)),
-	ADB_ENTRY(NID_pkcs7_enveloped, ASN1_NDEF_EXP_OPT(PKCS7, d.enveloped, PKCS7_ENVELOPE, 0)),
-	ADB_ENTRY(NID_pkcs7_signedAndEnveloped, ASN1_NDEF_EXP_OPT(PKCS7, d.signed_and_enveloped, PKCS7_SIGN_ENVELOPE, 0)),
-	ADB_ENTRY(NID_pkcs7_digest, ASN1_NDEF_EXP_OPT(PKCS7, d.digest, PKCS7_DIGEST, 0)),
-	ADB_ENTRY(NID_pkcs7_encrypted, ASN1_NDEF_EXP_OPT(PKCS7, d.encrypted, PKCS7_ENCRYPT, 0))
-} ASN1_ADB_END(PKCS7, 0, type, 0, &p7default_tt, NULL);
+ASN1_ADB_TEMPLATE(p7default)
+	ASN1_EXP_OPT1(PKCS7, d.other, ASN1_ANY, 0)
+ASN1_ADB_TEMPLATE_END
+
+ASN1_ADB_SEQ(PKCS7)
+	ADB_ENTRY(NID_pkcs7_data, ASN1_NDEF_EXP_OPT2(PKCS7, d.data, ASN1_OCTET_STRING_NDEF, 0))
+	ADB_ENTRY(NID_pkcs7_signed, ASN1_NDEF_EXP_OPT2(PKCS7, d.sign, PKCS7_SIGNED, 0))
+	ADB_ENTRY(NID_pkcs7_enveloped, ASN1_NDEF_EXP_OPT2(PKCS7, d.enveloped, PKCS7_ENVELOPE, 0))
+	ADB_ENTRY(NID_pkcs7_signedAndEnveloped, ASN1_NDEF_EXP_OPT2(PKCS7, d.signed_and_enveloped, PKCS7_SIGN_ENVELOPE, 0))
+	ADB_ENTRY(NID_pkcs7_digest, ASN1_NDEF_EXP_OPT2(PKCS7, d.digest, PKCS7_DIGEST, 0))
+	ADB_ENTRY(NID_pkcs7_encrypted, ASN1_NDEF_EXP_OPT2(PKCS7, d.encrypted, PKCS7_ENCRYPT, 0))
+ASN1_ADB_END(PKCS7, 0, type, 0, p7default_tt, NULL)
 
 /* PKCS#7 streaming support */
 static int pk7_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
 							void *exarg)
 {
-	ASN1_STREAM_ARG *sarg = exarg;
+	ASN1_STREAM_ARG *sarg = (ASN1_STREAM_ARG *)exarg;
 	PKCS7 **pp7 = (PKCS7 **)pval;
 
 	switch(operation)
@@ -106,23 +111,26 @@
 	return 1;
 }
 
-ASN1_NDEF_SEQUENCE_cb(PKCS7, pk7_cb) = {
-	ASN1_SIMPLE(PKCS7, type, ASN1_OBJECT),
+ASN1_NDEF_SEQUENCE_cb(PKCS7, pk7_cb)
+	ASN1_SIMPLE(PKCS7, type, ASN1_OBJECT)
 	ASN1_ADB_OBJECT(PKCS7)
-}ASN1_NDEF_SEQUENCE_END_cb(PKCS7, PKCS7)
+ASN1_NDEF_SEQUENCE_END_cb(PKCS7, PKCS7)
 
 IMPLEMENT_ASN1_FUNCTIONS(PKCS7)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_NDEF_FUNCTION(PKCS7)
 IMPLEMENT_ASN1_DUP_FUNCTION(PKCS7)
+#endif
+
 
-ASN1_NDEF_SEQUENCE(PKCS7_SIGNED) = {
-	ASN1_SIMPLE(PKCS7_SIGNED, version, ASN1_INTEGER),
-	ASN1_SET_OF(PKCS7_SIGNED, md_algs, X509_ALGOR),
-	ASN1_SIMPLE(PKCS7_SIGNED, contents, PKCS7),
-	ASN1_IMP_SEQUENCE_OF_OPT(PKCS7_SIGNED, cert, X509, 0),
-	ASN1_IMP_SET_OF_OPT(PKCS7_SIGNED, crl, X509_CRL, 1),
+ASN1_NDEF_SEQUENCE(PKCS7_SIGNED)
+	ASN1_SIMPLE(PKCS7_SIGNED, version, ASN1_INTEGER)
+	ASN1_SET_OF(PKCS7_SIGNED, md_algs, X509_ALGOR)
+	ASN1_SIMPLE(PKCS7_SIGNED, contents, PKCS7)
+	ASN1_IMP_SEQUENCE_OF_OPT(PKCS7_SIGNED, cert, X509, 0)
+	ASN1_IMP_SET_OF_OPT(PKCS7_SIGNED, crl, X509_CRL, 1)
 	ASN1_SET_OF(PKCS7_SIGNED, signer_info, PKCS7_SIGNER_INFO)
-} ASN1_NDEF_SEQUENCE_END(PKCS7_SIGNED)
+ASN1_NDEF_SEQUENCE_END(PKCS7_SIGNED)
 
 IMPLEMENT_ASN1_FUNCTIONS(PKCS7_SIGNED)
 
@@ -137,37 +145,41 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_cb(PKCS7_SIGNER_INFO, si_cb) = {
-	ASN1_SIMPLE(PKCS7_SIGNER_INFO, version, ASN1_INTEGER),
-	ASN1_SIMPLE(PKCS7_SIGNER_INFO, issuer_and_serial, PKCS7_ISSUER_AND_SERIAL),
-	ASN1_SIMPLE(PKCS7_SIGNER_INFO, digest_alg, X509_ALGOR),
+ASN1_SEQUENCE_cb(PKCS7_SIGNER_INFO, si_cb)
+	ASN1_SIMPLE(PKCS7_SIGNER_INFO, version, ASN1_INTEGER)
+	ASN1_SIMPLE(PKCS7_SIGNER_INFO, issuer_and_serial, PKCS7_ISSUER_AND_SERIAL)
+	ASN1_SIMPLE(PKCS7_SIGNER_INFO, digest_alg, X509_ALGOR)
 	/* NB this should be a SET OF but we use a SEQUENCE OF so the
 	 * original order * is retained when the structure is reencoded.
 	 * Since the attributes are implicitly tagged this will not affect
 	 * the encoding.
 	 */
-	ASN1_IMP_SEQUENCE_OF_OPT(PKCS7_SIGNER_INFO, auth_attr, X509_ATTRIBUTE, 0),
-	ASN1_SIMPLE(PKCS7_SIGNER_INFO, digest_enc_alg, X509_ALGOR),
-	ASN1_SIMPLE(PKCS7_SIGNER_INFO, enc_digest, ASN1_OCTET_STRING),
+	ASN1_IMP_SEQUENCE_OF_OPT(PKCS7_SIGNER_INFO, auth_attr, X509_ATTRIBUTE, 0)
+	ASN1_SIMPLE(PKCS7_SIGNER_INFO, digest_enc_alg, X509_ALGOR)
+	ASN1_SIMPLE(PKCS7_SIGNER_INFO, enc_digest, ASN1_OCTET_STRING)
 	ASN1_IMP_SET_OF_OPT(PKCS7_SIGNER_INFO, unauth_attr, X509_ATTRIBUTE, 1)
-} ASN1_SEQUENCE_END_cb(PKCS7_SIGNER_INFO, PKCS7_SIGNER_INFO)
+ASN1_SEQUENCE_END_cb(PKCS7_SIGNER_INFO, PKCS7_SIGNER_INFO)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(PKCS7_SIGNER_INFO)
+#endif
 
-ASN1_SEQUENCE(PKCS7_ISSUER_AND_SERIAL) = {
-	ASN1_SIMPLE(PKCS7_ISSUER_AND_SERIAL, issuer, X509_NAME),
+ASN1_SEQUENCE(PKCS7_ISSUER_AND_SERIAL)
+	ASN1_SIMPLE(PKCS7_ISSUER_AND_SERIAL, issuer, X509_NAME)
 	ASN1_SIMPLE(PKCS7_ISSUER_AND_SERIAL, serial, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(PKCS7_ISSUER_AND_SERIAL)
+ASN1_SEQUENCE_END(PKCS7_ISSUER_AND_SERIAL)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(PKCS7_ISSUER_AND_SERIAL)
+#endif
 
-ASN1_NDEF_SEQUENCE(PKCS7_ENVELOPE) = {
-	ASN1_SIMPLE(PKCS7_ENVELOPE, version, ASN1_INTEGER),
-	ASN1_SET_OF(PKCS7_ENVELOPE, recipientinfo, PKCS7_RECIP_INFO),
+ASN1_NDEF_SEQUENCE(PKCS7_ENVELOPE)
+	ASN1_SIMPLE(PKCS7_ENVELOPE, version, ASN1_INTEGER)
+	ASN1_SET_OF(PKCS7_ENVELOPE, recipientinfo, PKCS7_RECIP_INFO)
 	ASN1_SIMPLE(PKCS7_ENVELOPE, enc_data, PKCS7_ENC_CONTENT)
-} ASN1_NDEF_SEQUENCE_END(PKCS7_ENVELOPE)
+ASN1_NDEF_SEQUENCE_END(PKCS7_ENVELOPE)
 
-IMPLEMENT_ASN1_FUNCTIONS(PKCS7_ENVELOPE)
+IMPLEMENT_ASN1_FUNCTIONS3(PKCS7_ENVELOPE)
 
 /* Minor tweak to operation: free up X509 */
 static int ri_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
@@ -180,50 +192,57 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_cb(PKCS7_RECIP_INFO, ri_cb) = {
-	ASN1_SIMPLE(PKCS7_RECIP_INFO, version, ASN1_INTEGER),
-	ASN1_SIMPLE(PKCS7_RECIP_INFO, issuer_and_serial, PKCS7_ISSUER_AND_SERIAL),
-	ASN1_SIMPLE(PKCS7_RECIP_INFO, key_enc_algor, X509_ALGOR),
+ASN1_SEQUENCE_cb(PKCS7_RECIP_INFO, ri_cb)
+	ASN1_SIMPLE(PKCS7_RECIP_INFO, version, ASN1_INTEGER)
+	ASN1_SIMPLE(PKCS7_RECIP_INFO, issuer_and_serial, PKCS7_ISSUER_AND_SERIAL)
+	ASN1_SIMPLE(PKCS7_RECIP_INFO, key_enc_algor, X509_ALGOR)
 	ASN1_SIMPLE(PKCS7_RECIP_INFO, enc_key, ASN1_OCTET_STRING)
-} ASN1_SEQUENCE_END_cb(PKCS7_RECIP_INFO, PKCS7_RECIP_INFO)
+ASN1_SEQUENCE_END_cb(PKCS7_RECIP_INFO, PKCS7_RECIP_INFO)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(PKCS7_RECIP_INFO)
+#endif
 
-ASN1_NDEF_SEQUENCE(PKCS7_ENC_CONTENT) = {
-	ASN1_SIMPLE(PKCS7_ENC_CONTENT, content_type, ASN1_OBJECT),
-	ASN1_SIMPLE(PKCS7_ENC_CONTENT, algorithm, X509_ALGOR),
+ASN1_NDEF_SEQUENCE(PKCS7_ENC_CONTENT)
+	ASN1_SIMPLE(PKCS7_ENC_CONTENT, content_type, ASN1_OBJECT)
+	ASN1_SIMPLE(PKCS7_ENC_CONTENT, algorithm, X509_ALGOR)
 	ASN1_IMP_OPT(PKCS7_ENC_CONTENT, enc_data, ASN1_OCTET_STRING_NDEF, 0)
-} ASN1_NDEF_SEQUENCE_END(PKCS7_ENC_CONTENT)
+ASN1_NDEF_SEQUENCE_END(PKCS7_ENC_CONTENT)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(PKCS7_ENC_CONTENT)
+#endif
+
 
-ASN1_NDEF_SEQUENCE(PKCS7_SIGN_ENVELOPE) = {
-	ASN1_SIMPLE(PKCS7_SIGN_ENVELOPE, version, ASN1_INTEGER),
-	ASN1_SET_OF(PKCS7_SIGN_ENVELOPE, recipientinfo, PKCS7_RECIP_INFO),
-	ASN1_SET_OF(PKCS7_SIGN_ENVELOPE, md_algs, X509_ALGOR),
-	ASN1_SIMPLE(PKCS7_SIGN_ENVELOPE, enc_data, PKCS7_ENC_CONTENT),
-	ASN1_IMP_SET_OF_OPT(PKCS7_SIGN_ENVELOPE, cert, X509, 0),
-	ASN1_IMP_SET_OF_OPT(PKCS7_SIGN_ENVELOPE, crl, X509_CRL, 1),
+ASN1_NDEF_SEQUENCE(PKCS7_SIGN_ENVELOPE)
+	ASN1_SIMPLE(PKCS7_SIGN_ENVELOPE, version, ASN1_INTEGER)
+	ASN1_SET_OF(PKCS7_SIGN_ENVELOPE, recipientinfo, PKCS7_RECIP_INFO)
+	ASN1_SET_OF(PKCS7_SIGN_ENVELOPE, md_algs, X509_ALGOR)
+	ASN1_SIMPLE(PKCS7_SIGN_ENVELOPE, enc_data, PKCS7_ENC_CONTENT)
+	ASN1_IMP_SET_OF_OPT(PKCS7_SIGN_ENVELOPE, cert, X509, 0)
+	ASN1_IMP_SET_OF_OPT(PKCS7_SIGN_ENVELOPE, crl, X509_CRL, 1)
 	ASN1_SET_OF(PKCS7_SIGN_ENVELOPE, signer_info, PKCS7_SIGNER_INFO)
-} ASN1_NDEF_SEQUENCE_END(PKCS7_SIGN_ENVELOPE)
+ASN1_NDEF_SEQUENCE_END(PKCS7_SIGN_ENVELOPE)
 
-IMPLEMENT_ASN1_FUNCTIONS(PKCS7_SIGN_ENVELOPE)
+IMPLEMENT_ASN1_FUNCTIONS3(PKCS7_SIGN_ENVELOPE)
 
-ASN1_NDEF_SEQUENCE(PKCS7_ENCRYPT) = {
-	ASN1_SIMPLE(PKCS7_ENCRYPT, version, ASN1_INTEGER),
+ASN1_NDEF_SEQUENCE(PKCS7_ENCRYPT)
+	ASN1_SIMPLE(PKCS7_ENCRYPT, version, ASN1_INTEGER)
 	ASN1_SIMPLE(PKCS7_ENCRYPT, enc_data, PKCS7_ENC_CONTENT)
-} ASN1_NDEF_SEQUENCE_END(PKCS7_ENCRYPT)
+ASN1_NDEF_SEQUENCE_END(PKCS7_ENCRYPT)
 
-IMPLEMENT_ASN1_FUNCTIONS(PKCS7_ENCRYPT)
+IMPLEMENT_ASN1_FUNCTIONS3(PKCS7_ENCRYPT)
 
-ASN1_NDEF_SEQUENCE(PKCS7_DIGEST) = {
-	ASN1_SIMPLE(PKCS7_DIGEST, version, ASN1_INTEGER),
-	ASN1_SIMPLE(PKCS7_DIGEST, md, X509_ALGOR),
-	ASN1_SIMPLE(PKCS7_DIGEST, contents, PKCS7),
+ASN1_NDEF_SEQUENCE(PKCS7_DIGEST)
+	ASN1_SIMPLE(PKCS7_DIGEST, version, ASN1_INTEGER)
+	ASN1_SIMPLE(PKCS7_DIGEST, md, X509_ALGOR)
+	ASN1_SIMPLE(PKCS7_DIGEST, contents, PKCS7)
 	ASN1_SIMPLE(PKCS7_DIGEST, digest, ASN1_OCTET_STRING)
-} ASN1_NDEF_SEQUENCE_END(PKCS7_DIGEST)
+ASN1_NDEF_SEQUENCE_END(PKCS7_DIGEST)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(PKCS7_DIGEST)
+#endif
 
 /* Specials for authenticated attributes */
 
@@ -231,7 +250,7 @@
  * encoding.
  */
 
-ASN1_ITEM_TEMPLATE(PKCS7_ATTR_SIGN) = 
+ASN1_ITEM_TEMPLATE(PKCS7_ATTR_SIGN)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SET_ORDER, 0, PKCS7_ATTRIBUTES, X509_ATTRIBUTE)
 ASN1_ITEM_TEMPLATE_END(PKCS7_ATTR_SIGN)
 
@@ -239,9 +258,11 @@
  * we use SEQUENCE OF and tag it to SET OF
  */
 
-ASN1_ITEM_TEMPLATE(PKCS7_ATTR_VERIFY) = 
+#ifndef OPERA_SMALL_VERSION
+ASN1_ITEM_TEMPLATE(PKCS7_ATTR_VERIFY)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF | ASN1_TFLG_IMPTAG | ASN1_TFLG_UNIVERSAL,
 				V_ASN1_SET, PKCS7_ATTRIBUTES, X509_ATTRIBUTE)
 ASN1_ITEM_TEMPLATE_END(PKCS7_ATTR_VERIFY)
 
 IMPLEMENT_ASN1_PRINT_FUNCTION(PKCS7)
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_attr.c openssl-1.0.0q/crypto/pkcs7/pk7_attr.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_attr.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_attr.c	2017-04-25 16:23:40.595620949 +0200
@@ -56,8 +56,12 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
@@ -65,6 +69,8 @@
 #include <openssl/pkcs7.h>
 #include <openssl/x509.h>
 #include <openssl/err.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 int PKCS7_add_attrib_smimecap(PKCS7_SIGNER_INFO *si, STACK_OF(X509_ALGOR) *cap)
 {
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_dgst.c openssl-1.0.0q/crypto/pkcs7/pk7_dgst.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_dgst.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_dgst.c	2017-04-25 16:23:40.596621076 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/rand.h>
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_doit.c openssl-1.0.0q/crypto/pkcs7/pk7_doit.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_doit.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_doit.c	2017-04-25 16:23:40.597620644 +0200
@@ -56,14 +56,20 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/rand.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 #include <openssl/err.h>
 
+#include "modules/libopeay/libopeay_arrays.h"
+
+
 static int add_attribute(STACK_OF(X509_ATTRIBUTE) **sk, int nid, int atrtype,
 			 void *value);
 static ASN1_TYPE *get_attribute(STACK_OF(X509_ATTRIBUTE) *sk, int nid);
@@ -169,7 +175,7 @@
 	if (EVP_PKEY_encrypt(pctx, NULL, &eklen, key, keylen) <= 0)
 		goto err;
 
-	ek = OPENSSL_malloc(eklen);
+	ek = (unsigned char *)OPENSSL_malloc(eklen);
 
 	if (ek == NULL)
 		{
@@ -197,6 +203,7 @@
 	}
 
 
+#ifndef OPERA_SMALL_VERSION
 static int pkcs7_decrypt_rinfo(unsigned char **pek, int *peklen,
 			       PKCS7_RECIP_INFO *ri, EVP_PKEY *pkey)
 	{
@@ -259,6 +266,7 @@
 
 	return ret;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 BIO *PKCS7_dataInit(PKCS7 *p7, BIO *bio)
 	{
@@ -324,8 +332,8 @@
 
 	if (evp_cipher != NULL)
 		{
-		unsigned char key[EVP_MAX_KEY_LENGTH];
-		unsigned char iv[EVP_MAX_IV_LENGTH];
+		unsigned char key[EVP_MAX_KEY_LENGTH]; /* ARRAY OK 2004-02-18 yngve */
+		unsigned char iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK 2004-02-18 yngve */
 		int keylen,ivlen;
 		EVP_CIPHER_CTX *ctx;
 
@@ -405,6 +413,7 @@
 	return(out);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 static int pkcs7_cmp_ri(PKCS7_RECIP_INFO *ri, X509 *pcert)
 	{
 	int ret;
@@ -507,8 +516,8 @@
 	if (evp_cipher != NULL)
 		{
 #if 0
-		unsigned char key[EVP_MAX_KEY_LENGTH];
-		unsigned char iv[EVP_MAX_IV_LENGTH];
+		unsigned char key[EVP_MAX_KEY_LENGTH];	/* ARRAY OK UNUSED 2004-02-18 yngve */
+		unsigned char iv[EVP_MAX_IV_LENGTH];	/* ARRAY OK UNUSED 2004-02-18 yngve */
 		unsigned char *p;
 		int keylen,ivlen;
 		int max;
@@ -681,6 +690,7 @@
 		}
 	return(out);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 static BIO *PKCS7_find_digest(EVP_MD_CTX **pmd, BIO *bio, int nid)
 	{
@@ -702,12 +712,21 @@
 			return bio;
 		bio=BIO_next(bio);
 		}
+
+// Suppress warning "unreachable code".
+// TODO: submit a patch to OpenSSL about removing the return.
+#ifdef OPERA_SMALL_VERSION
+# if OPENSSL_VERSION_NUMBER != 0x1000007fL
+//#  error "Revisit this local patch on upgrade. The code may suddenly become reachable."
+# endif
+#else
 	return NULL;
+#endif // OPERA_SMALL_VERSION
 	}
 
 static int do_pkcs7_signed_attrib(PKCS7_SIGNER_INFO *si, EVP_MD_CTX *mctx)
 	{
-	unsigned char md_data[EVP_MAX_MD_SIZE];
+	unsigned char md_data[EVP_MAX_MD_SIZE]; /* ARRAY OK UNUSED 2011-09-12 alexeik */
 	unsigned int md_len;
 
 	/* Add signing time if not already present */
@@ -735,8 +754,7 @@
 
 	return 1;
 	}
-	
-				
+
 int PKCS7_dataFinal(PKCS7 *p7, BIO *bio)
 	{
 	int ret=0;
@@ -846,7 +864,7 @@
 				unsigned char *abuf = NULL;
 				unsigned int abuflen;
 				abuflen = EVP_PKEY_size(si->pkey);
-				abuf = OPENSSL_malloc(abuflen);
+				abuf = (unsigned char *)OPENSSL_malloc(abuflen);
 				if (!abuf)
 					goto err;
 
@@ -930,7 +948,7 @@
 	abuf = NULL;
 	if (EVP_DigestSignFinal(&mctx, NULL, &siglen) <= 0)
 		goto err;
-	abuf = OPENSSL_malloc(siglen);
+	abuf = (unsigned char *)OPENSSL_malloc(siglen);
 	if(!abuf)
 		goto err;
 	if (EVP_DigestSignFinal(&mctx, abuf, &siglen) <= 0)
@@ -957,6 +975,7 @@
 
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int PKCS7_dataVerify(X509_STORE *cert_store, X509_STORE_CTX *ctx, BIO *bio,
 	     PKCS7 *p7, PKCS7_SIGNER_INFO *si)
 	{
@@ -1067,7 +1086,7 @@
 	sk=si->auth_attr;
 	if ((sk != NULL) && (sk_X509_ATTRIBUTE_num(sk) != 0))
 		{
-		unsigned char md_dat[EVP_MAX_MD_SIZE], *abuf = NULL;
+		unsigned char md_dat[EVP_MAX_MD_SIZE], *abuf = NULL; /* ARRAY OK 2004-02-18 yngve */
                 unsigned int md_len;
 		int alen;
 		ASN1_OCTET_STRING *message_digest;
@@ -1081,7 +1100,7 @@
 			goto err;
 			}
 		if ((message_digest->length != (int)md_len) ||
-			(memcmp(message_digest->data,md_dat,md_len)))
+			(op_memcmp(message_digest->data,md_dat,md_len)))
 			{
 #if 0
 {
@@ -1155,6 +1174,7 @@
 	ri=sk_PKCS7_RECIP_INFO_value(rsk,idx);
 	return(ri->issuer_and_serial);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 ASN1_TYPE *PKCS7_get_signed_attribute(PKCS7_SIGNER_INFO *si, int nid)
 	{
@@ -1188,6 +1208,7 @@
 	return(NULL);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 ASN1_OCTET_STRING *PKCS7_digest_from_attributes(STACK_OF(X509_ATTRIBUTE) *sk)
 {
 	ASN1_TYPE *astype;
@@ -1234,6 +1255,7 @@
 		}
 	return(1);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 int PKCS7_add_signed_attribute(PKCS7_SIGNER_INFO *p7si, int nid, int atrtype,
 	     void *value)
@@ -1292,4 +1314,3 @@
 end:
 	return(1);
 	}
-
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_enc.c openssl-1.0.0q/crypto/pkcs7/pk7_enc.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_enc.c	2017-04-25 16:23:40.598620492 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/rand.h>
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_lib.c openssl-1.0.0q/crypto/pkcs7/pk7_lib.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_lib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_lib.c	2017-04-25 16:23:40.599621178 +0200
@@ -56,11 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
 
 long PKCS7_ctrl(PKCS7 *p7, int cmd, long larg, char *parg)
 	{
@@ -112,6 +115,7 @@
 	return(ret);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int PKCS7_content_new(PKCS7 *p7, int type)
 	{
 	PKCS7 *ret=NULL;
@@ -155,6 +159,7 @@
 err:
 	return(0);
 	}
+#endif
 
 int PKCS7_set_type(PKCS7 *p7, int type)
 	{
@@ -210,6 +215,7 @@
 						= OBJ_nid2obj(NID_pkcs7_data);
 		break;
 
+#ifndef OPERA_SMALL_VERSION
 	case NID_pkcs7_digest:
 		p7->type=obj;
 		if ((p7->d.digest=PKCS7_DIGEST_new())
@@ -217,6 +223,7 @@
 		if (!ASN1_INTEGER_set(p7->d.digest->version,0))
 			goto err;
 		break;
+#endif
 	default:
 		PKCS7err(PKCS7_F_PKCS7_SET_TYPE,PKCS7_R_UNSUPPORTED_CONTENT_TYPE);
 		goto err;
@@ -226,13 +233,7 @@
 	return(0);
 	}
 
-int PKCS7_set0_type_other(PKCS7 *p7, int type, ASN1_TYPE *other)
-	{
-	p7->type = OBJ_nid2obj(type);
-	p7->d.other = other;
-	return 1;
-	}
-
+#ifndef OPERA_SMALL_VERSION
 int PKCS7_add_signer(PKCS7 *p7, PKCS7_SIGNER_INFO *psi)
 	{
 	int i,j,nid;
@@ -291,6 +292,7 @@
 		return 0;
 	return(1);
 	}
+#endif
 
 int PKCS7_add_certificate(PKCS7 *p7, X509 *x509)
 	{
@@ -327,6 +329,7 @@
 	return(1);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int PKCS7_add_crl(PKCS7 *p7, X509_CRL *crl)
 	{
 	int i;
@@ -470,6 +473,7 @@
 	else
 		return(NULL);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 void PKCS7_SIGNER_INFO_get0_algs(PKCS7_SIGNER_INFO *si, EVP_PKEY **pk,
 					X509_ALGOR **pdig, X509_ALGOR **psig)
@@ -488,6 +492,7 @@
 		*penc = ri->key_enc_algor;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 PKCS7_RECIP_INFO *PKCS7_add_recipient(PKCS7 *p7, X509 *x509)
 	{
 	PKCS7_RECIP_INFO *ri;
@@ -617,6 +622,7 @@
 	ec->cipher = cipher;
 	return 1;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 int PKCS7_stream(unsigned char ***boundary, PKCS7 *p7)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_mime.c openssl-1.0.0q/crypto/pkcs7/pk7_mime.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_mime.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_mime.c	2017-04-25 16:23:40.599621178 +0200
@@ -52,8 +52,13 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/rand.h>
 #include <openssl/x509.h>
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pk7_smime.c openssl-1.0.0q/crypto/pkcs7/pk7_smime.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pk7_smime.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pk7_smime.c	2017-04-25 16:23:40.600620746 +0200
@@ -58,7 +58,12 @@
 
 /* Simple PKCS#7 processing functions */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
diff -Naur openssl-1.0.0q.orig/crypto/pkcs7/pkcs7err.c openssl-1.0.0q/crypto/pkcs7/pkcs7err.c
--- openssl-1.0.0q.orig/crypto/pkcs7/pkcs7err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs7/pkcs7err.c	2017-04-25 16:23:40.601621432 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/pkcs7.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/pqueue/.gitignore openssl-1.0.0q/crypto/pqueue/.gitignore
--- openssl-1.0.0q.orig/crypto/pqueue/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/pqueue/.gitignore	2017-04-25 16:23:40.601621432 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/rand/.gitignore openssl-1.0.0q/crypto/rand/.gitignore
--- openssl-1.0.0q.orig/crypto/rand/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/.gitignore	2017-04-25 16:23:40.602621280 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
